package com.ruoyi.demo;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ArrayUtil;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

import java.io.*;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.nio.channels.*;
import java.nio.channels.spi.SelectorProvider;
import java.nio.charset.StandardCharsets;
import java.util.Iterator;
import java.util.Locale;
import java.util.concurrent.LinkedBlockingQueue;

/**
 * @author: jd
 * @Description:
 * @create: 2023/4/11
 */
@Component
public class SendTestData  implements ApplicationRunner {

    public static final String aa = "15 A0 4D 05 ED C8 B8 2C C3 5F 49 F7 08 E8 44 9E D9 AE 9C E3 13 FA 4F 85 E0 C1 11 3A 7C E4 A8 4B 2C 34 01 7E AB F1 8F BD A9 EA 7D 13 BF 83 BB 84 BA 75 BD 75 1B EF 52 31 FA 38 B0 5A BA 1F C2 AD E3 F0 6E AE 7D 17 A4 20 B1 E0 4E 0F 7A D0 C3 4F E4 41 20 9B F1 75 54 01 04 F9 76 51 45 B5 28 ED 22 47 CF D9 E9 90 40 9D 14 C8 20 08 62 31 12 2C D1 36 B5 18 9A 39 8A B7 48 57 5D F7 68 CD F3 23 9C 23 32 83 0E 33 BF 8A 1B 0E 7F 18 CF 79 95 18 6B CD A9 89 13 DF C4 77 8D D1 2B 6C DF 6F 5F CF 50 86 10 5A E6 A8 B7 5F 85 EA 8D 1F DD 84 59 FD B9 6D 23 91 5C 57 72 55 E4 B8 A2 17 17 00 73 B4 69 A5 19 13 F6 06 EF 53 DA 20 69 01 1B 99 34 4A 8B 34 88 02 3C 9A EB 26 6D D5 7F A3 AA AA E9 1B D9 2A 72 9E 06 62 E5 E5 0A FA 6F D1 6C 48 3B 64 E7 02 B3 3B 22 CA E2 20 36 2D C2 30 0B A9 A7 77 CA 58 B2 DF 58 BC 84 6E 7C DA 68 FD 03 8D 9B 30 B9 04 3B F1 16 72 84 91 E5 4D FE CC 70 1C BC DB 6D 8A 13 2B E0 93 E7 BD 74 60 BB 1A 22 EC BF D0 7B 7E A1 A6 F0 6F FE 0A F9 60 29 C6 86 16 D0 F5 DE BA FE 6D AE 0D E5 59 54 42 19 94 F3 ";

    @Override
    public void run(ApplicationArguments args) throws Exception{
//        init2();
    }

    public static void main(String[] args) throws Exception {
        init2();
    }

    public static void init2() throws Exception{
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < 50; i++) {
            sb.append(aa);
        }
        ServerSocketChannel server = ServerSocketChannel.open();
        // 绑定监听端口
        server.bind(new InetSocketAddress(8082));
        //非阻塞的方式
        server.configureBlocking(false);
        // 创建 selector 对象
        Selector selector = server.provider().openSelector();
        // 只关注accept事件 （accept 事件 - 会在有连接请求时触发）
        server.register(selector, SelectionKey.OP_ACCEPT);

        System.out.println("系统已就绪等待mcu设备连接。。。<br/>");
        while (true) {
            selector.select();
            // selector会在发生事件后，向selectedKeys加入key，但不会删除
            Iterator<SelectionKey> keyIterator = selector.selectedKeys().iterator();
            while (keyIterator.hasNext()) {
                SelectionKey sk = keyIterator.next();
                // 处理key时，要从selectedKeys集合汇总删除，否则下次处理就会出空指针
                keyIterator.remove();
                if(sk.isAcceptable()){
                    ServerSocketChannel ssc = (ServerSocketChannel) sk.channel();
                    SocketChannel socketChannel = ssc.accept();
                    socketChannel.configureBlocking(false);
                    String ip = socketChannel.getRemoteAddress().toString().substring(1);
                    System.out.println("IP需要应答:" + ip + "<br/>");
                    Event event = new Event(sb.toString());
                    event.register(socketChannel, SelectionKey.OP_READ);
                }
            }
        }
    }

    public static void init() throws IOException{
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < 50; i++) {
            sb.append(aa);
        }
        ServerSocket server = null;
        Socket socket = null;
        BufferedReader in = null;
        try {
            // 创建服务器
            server = new ServerSocket(8082);
            System.out.println("测试心跳服务已启动，等待应答中。。。。。");

            while (true){
                socket = server.accept();
                System.out.println("收到一个心跳。。。。。");
                // 输出时间
                Writer out = new OutputStreamWriter(socket.getOutputStream());
                out.write(sb.toString() + "\r\n");
                out.flush();

                in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
                System.out.println("Client:"+in.readLine());

                // 关闭资源
                in.close(); //关闭Socket输入流
                socket.close(); //关闭Socket
            }
        }catch (Exception e){
            in.close(); //关闭Socket输入流
            socket.close(); //关闭Socket
            server.close(); //关闭ServerSocket
        }
    }
}

class Event implements Runnable{
    private final Selector selector;
    private final byte[] responseBytes;

    private Thread thread;
    private int queueNum=16;
    private LinkedBlockingQueue<Runnable> taskQueue;

    public Event(String responseBytes) throws IOException {
        this.responseBytes = responseBytes.getBytes(StandardCharsets.UTF_8);
        taskQueue = new LinkedBlockingQueue<>(queueNum);
        this.selector = SelectorProvider.provider().openSelector();
        this.thread = new Thread(this);
        this.thread.start();
    }

    public void register(SocketChannel socketChannel, int keyOps) throws InterruptedException {
        //放入taskQueue，并没有在这里执行下端代码，在下面调用task.run()中执行
        taskQueue.put(()->{
            try {
                SelectionKey selectionKey = socketChannel.register(selector, keyOps);
                selectionKey.attach(socketChannel);
            } catch (ClosedChannelException e) {
                e.printStackTrace();
            }
        });
        //唤起selector上阻塞的线程
        selector.wakeup();
    }

    @Override
    public void run() {
        while (!Thread.currentThread().isInterrupted()){
            try {
                int eventNum = selector.select();
                //1.eventNum>0如果有事件说明就是读写事件；2.eventNum=0如果没有事件，就是添加新的taskQueue对象事件。
                if(eventNum>0) {
                    Iterator<SelectionKey> keyIterator = selector.selectedKeys().iterator();
                    while (keyIterator.hasNext()) {
                        SelectionKey selectionKey = keyIterator.next();
                        keyIterator.remove();

                        StringBuilder sb = new StringBuilder();
                        for (int i = 0; i < 50; i++) {
                            sb.append(SendTestData.aa);
                        }

                        String remoteAddress = "";
                        try {
                            //获取channel
                            SocketChannel channel = (SocketChannel) selectionKey.attachment();
                            if(channel!=null){
                                remoteAddress = channel.getRemoteAddress().toString();
                            }

                            //远程突然无条件断开连接
                            if (!selectionKey.isValid()) {
                                System.out.println("IP突然断开连接:" + remoteAddress + "<br/>");
                                break;
                            }

                            // read 事件
                            if (selectionKey.isReadable()) {
                                // 获取数据
                                ByteBuffer buffer = ByteBuffer.allocate(4096);
                                int readNum;
                                while ((readNum=channel.read(buffer))>0) {
                                    channel.read(buffer);
                                    buffer.flip();
                                }
                                // 客户如果正常断开连接 read()方法的返回值是 -1
                                if (readNum == -1) {
                                    System.out.println("IP正常断开连接:" + remoteAddress + "<br/>");
                                    selectionKey.cancel();
                                    channel.close();
                                    return;
                                }
                                //此处是把收到的信息 buff--》byte[]（类似于 “01 02 03 04 05 06”）--》16进制数据
                                String content = Convert.toHex(ArrayUtil.toArray(buffer)).toUpperCase(Locale.ROOT);
                                System.out.println("接收到数据：" + content);

                                //回复消息
                                if (responseBytes != null) {
                                    selectionKey.interestOps(SelectionKey.OP_WRITE);
                                }
                            }
                            //回复数据
                            if (selectionKey.isWritable()) {
                                ByteBuffer buffer = ByteBuffer.wrap(responseBytes);
                                while (buffer!=null){
                                    channel.write(buffer);
                                }
                                selectionKey.interestOps(SelectionKey.OP_READ);
                                System.out.println("数据发送完成！设备ip:" + remoteAddress);
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                            selectionKey.cancel();
                            break;
                        }
                    }
                }
                Runnable task;
                while ((task = taskQueue.poll()) != null) {
                    task.run();
                }

            }catch (IOException e){
                e.printStackTrace();
            }
        }
    }
}
