package com.ruoyi.advertiser25.controller;

import com.ruoyi.advertiser25.domain.AdHeartbeatData25;
import com.ruoyi.advertiser25.domain.vo.AdHeartbeatDataVo25;
import com.ruoyi.advertiser25.service.IDeviceHeartbeatService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 拉手心跳数据Controller
 *
 * @author zhangzhanwei
 * @date 2021-12-16
 */
@RestController
@RequestMapping("/mcu25/heartbeat_data")
public class DeviceHeartbeatController extends BaseController
{
    @Autowired
    private IDeviceHeartbeatService adHeartbeatDataService;

    /**
     * 查询拉手心跳数据列表
     */
    @GetMapping("/list")
    public TableDataInfo list(AdHeartbeatData25 adHeartbeatData25)
    {
        startPage();
        List<AdHeartbeatData25> list = adHeartbeatDataService.selectAdHeartbeatDataList(adHeartbeatData25);
        return getDataTable(list);
    }

    /**
     * 查询拉手心跳数据列表
     */
    @GetMapping("/listByHandle")
    public TableDataInfo listByHandle(AdHeartbeatData25 adHeartbeatData25)
    {
        startPage();
        List<AdHeartbeatData25> list = adHeartbeatDataService.selectAdHeartbeatDataInfoList(adHeartbeatData25);
        return getDataTable(list);
    }

    /**
     * 查询拉手心跳数据列表
     */
    @GetMapping("/listByImei")
    public TableDataInfo listByImei(AdHeartbeatData25 adHeartbeatData25)
    {
        startPage();
        List<AdHeartbeatData25> list = adHeartbeatDataService.selectAdHeartbeatDataList(adHeartbeatData25);
        List<AdHeartbeatDataVo25> list2 = list.stream().map(p->{
            AdHeartbeatDataVo25 obj = new AdHeartbeatDataVo25();
            BeanUtils.copyProperties(p,obj);
            return obj;
        }).collect(Collectors.toList());
        return getDataTable(list2);
    }

    /**
     * 获取拉手心跳数据详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return AjaxResult.success(adHeartbeatDataService.selectAdHeartbeatDataById(id));
    }

    /**
     * 新增拉手心跳数据
     */
    @PostMapping
    public AjaxResult add(@RequestBody AdHeartbeatData25 adHeartbeatData25)
    {
        return toAjax(adHeartbeatDataService.insertAdHeartbeatData(adHeartbeatData25));
    }

    /**
     * 修改拉手心跳数据
     */
    @PutMapping
    public AjaxResult edit(@RequestBody AdHeartbeatData25 adHeartbeatData25)
    {
        return toAjax(adHeartbeatDataService.updateAdHeartbeatData(adHeartbeatData25));
    }

    /**
     * 删除拉手心跳数据
     */
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(adHeartbeatDataService.deleteAdHeartbeatDataByIds(ids));
    }
}
