package com.ruoyi.advertiser25.controller;

import com.ruoyi.advertiser25.domain.PlanSetting25;
import com.ruoyi.advertiser25.domain.req.CarouselPlanParamReq25;
import com.ruoyi.advertiser25.service.IPlanSettingService;
import com.ruoyi.advertiser25.service.IRotationPlanService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.SecurityUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 广告轮播计划 Controller
 *
 * @author zhangzhanwei
 * @date 2021-09-24
 */
@RestController
@RequestMapping("/advertising25/plan")
@Api(tags = "轮播计划接口详情")
public class RotationPlanController extends BaseController {

    @Resource
    private IRotationPlanService adCarouselPlanService;

    @Resource
    private IPlanSettingService planSettingService;

    @GetMapping("/groupDict")
    public AjaxResult groupDict(){
        PlanSetting25 planSetting = new PlanSetting25();
        planSetting.setCreateBy(SecurityUtils.getUsername());
        return AjaxResult.success(planSettingService.selectPlanSettingList(planSetting));
    }

    /**
     * 查询广告轮播计划 精确到列车
     */
    @ApiOperation(value = "查询广告轮播计划")
    @GetMapping("/planInfo")
    public AjaxResult planInfo(@Validated CarouselPlanParamReq25 carouselPlanParamVo) {
        return adCarouselPlanService.selectPlanByParamVo(carouselPlanParamVo);
    }

    @GetMapping("/pushRedis")
    private AjaxResult pushRedis(){
        return adCarouselPlanService.pushRedis();
    }
}
