package com.ruoyi.advertiser25.controller;

import com.ruoyi.advertiser25.domain.Material25;
import com.ruoyi.advertiser25.service.IScreenMaterialService;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 广告素材 Controller
 *
 * @author zhangzhanwei
 * @date 2021-09-13
 */
@RestController
@RequestMapping("/advertising25/material")
public class ScreenMaterialController extends BaseController {

    @Resource
    private IScreenMaterialService materialService;

    /**
     * 查询广告素材 列表
     */
    @GetMapping("/list")
    public TableDataInfo list(Material25 material25) {
        startPage();
        List<Material25> list = materialService.selectMaterialList(material25);
        return getDataTable(list);
    }

    /**
     * 新增广告素材
     */
    @Log(title = "广告素材 ", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody Material25 material25) {
        return toAjax(materialService.insertMaterial(material25));
    }

    /**
     * 获取广告素材 详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return AjaxResult.success(materialService.selectMaterialById(id));
    }

    /**
     * 修改广告素材
     */
    @Log(title = "广告素材 ", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody Material25 material25) {
        return toAjax(materialService.updateMaterial(material25));
    }

    /**
     * 删除广告素材
     */
    @Log(title = "广告素材 ", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(materialService.deleteMaterialByIds(ids));
    }

    /**
     * 图片签名
     */
    @Log(title = "广告素材 ", businessType = BusinessType.UPDATE)
    @PutMapping("/pass")
    public AjaxResult pass(@RequestBody Material25 Material25) {
        return materialService.passMaterial(Material25);
    }

    @GetMapping("/demo/{id}")
    public AjaxResult demo(@PathVariable Long id){
        return materialService.demo(id);
    }

    @GetMapping("/getDemoPic")
    public AjaxResult getDemoPic(){
        return materialService.getDemoPic();
    }

}
