package com.ruoyi.advertiser25.mapper;

import com.ruoyi.advertiser25.domain.AdHeartbeatData25;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 拉手心跳数据Mapper接口
 *
 * @author zhangzhanwei
 * @date 2021-12-16
 */
public interface DeviceHeartbeatMapper
{
    /**
     * 查询拉手心跳数据
     *
     * @param id 拉手心跳数据主键
     * @return 拉手心跳数据
     */
    public AdHeartbeatData25 selectAdHeartbeatDataById(Long id);

    /**
     * 查询拉手心跳数据列表
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 拉手心跳数据集合
     */
    public List<AdHeartbeatData25> selectAdHeartbeatDataList(AdHeartbeatData25 adHeartbeatData25);

    List<AdHeartbeatData25> selectAdHeartbeatDataInfoList(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 新增拉手心跳数据
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 结果
     */
    public int insertAdHeartbeatData(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 修改拉手心跳数据
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 结果
     */
    public int updateAdHeartbeatData(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 删除拉手心跳数据
     *
     * @param id 拉手心跳数据主键
     * @return 结果
     */
    public int deleteAdHeartbeatDataById(Long id);

    /**
     * 批量删除拉手心跳数据
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAdHeartbeatDataByIds(Long[] ids);

    List<AdHeartbeatData25> selectHandlerLocationBySubwayId(@Param("params") Map<String,Object> params);


    AdHeartbeatData25 selectAdHeartbeatDataByImei(String imei);
}
