package com.ruoyi.advertiser25.mapper;

import com.ruoyi.advertiser25.domain.PlanSetting25;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 把手 Mapper接口
 *
 * @author zhangzhanwei
 * @date 2021-09-15
 */
public interface PlanSettingMapper {
    /**
     * 查询把手
     *
     * @param id 把手 ID
     * @return 把手
     */
    PlanSetting25 selectPlanSettingById(Long id);

    /**
     * 查询把手 列表
     *
     * @param planSetting25 把手
     * @return 把手 集合
     */
    List<PlanSetting25> selectPlanSettingList(PlanSetting25 planSetting25);

    /**
     * 新增把手
     *
     * @param planSetting25 把手
     * @return 结果
     */
    int insertPlanSetting(PlanSetting25 planSetting25);

    /**
     * 修改把手
     *
     * @param planSetting25 把手
     * @return 结果
     */
    int updatePlanSetting(PlanSetting25 planSetting25);

    /**
     * 批量删除把手
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    int deletePlanSettingByIds(Long[] ids);


    /**
     * 验证把手编号是否重复
     * @param PlanSetting25
     * @return
     */
    int checkNumUnique(PlanSetting25 PlanSetting25);

    /**
     * 定时器修改拉手状态
     * @param params
     * @return
     */
    int updateOnlineStatusTask(@Param("params") Map<String,Object> params);
}
