package com.ruoyi.advertiser25.mapper;

import com.ruoyi.advertiser25.domain.CarouselPlan25;
import com.ruoyi.advertiser25.domain.dto.CarouselPlanPicDto25;
import com.ruoyi.advertiser25.domain.req.CarouselPlanParamReq25;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * 广告轮播计划 Mapper接口
 *
 * @author zhangzhanwei
 * @date 2021-09-24
 */
public interface RotationPlanMapper
{
    /**
     * 查询广告轮播计划
     *
     * @param id 广告轮播计划 主键
     * @return 广告轮播计划
     */
    public CarouselPlan25 selectAdCarouselPlanById(Long id);

    /**
     * 新增广告轮播计划
     *
     * @param adCarouselPlan25 广告轮播计划
     * @return 结果
     */
    public int insertAdCarouselPlan(CarouselPlan25 adCarouselPlan25);

    /**
     * 修改广告轮播计划
     *
     * @param adCarouselPlan25 广告轮播计划
     * @return 结果
     */
    public int updateAdCarouselPlan(CarouselPlan25 adCarouselPlan25);

    /**
     * 批量删除广告轮播计划
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAdCarouselPlanByIds(Long[] ids);

    /**
     * 批量新增广告轮播计划数据
     * @param carouselPlan25s
     * @return
     */
    Integer insertAdCarouselPlanBatch(List<CarouselPlan25> carouselPlan25s);

    CarouselPlan25 selectPlanByParamVo(CarouselPlanParamReq25 carouselPlanParamVo);

    /**
     * 说明：删除时间段内轮播计划
     * @param startTime
     * @param endTime
     * @return
     */
    Integer deleteAdCarouselPlanByTime(@Param("startTime") Date startTime,
                                       @Param("endTime") Date endTime);

}
