package com.ruoyi.advertiser25.mapper;

import com.ruoyi.advertiser25.domain.Material25;
import com.ruoyi.advertiser25.domain.dto.MaterialUrlDto25;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 广告素材 Mapper接口
 *
 * @author zhangzhanwei
 * @date 2021-09-13
 */
public interface ScreenMaterialMapper {

    /**
     * 查询广告素材 列表
     *
     * @param material25 广告素材
     * @return 广告素材 集合
     */
    List<Material25> selectMaterialList(Material25 material25);

    /**
     * 新增广告素材
     *
     * @param material25 广告素材
     * @return 结果
     */
    int insertMaterial(Material25 material25);

    /**
     * 查询广告素材
     *
     * @param id 广告素材 ID
     * @return 广告素材
     */
    Material25 selectMaterialById(Long id);

    /**
     * 批量删除广告素材
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    int deleteMaterialByIds(Long[] ids);

    /**
     * 修改广告素材
     *
     * @param material25 广告素材
     * @return 结果
     */
    int updateMaterial(Material25 material25);

    /**
     * 根据id组查询广告素材
     * @param ids
     * @return
     */
    List<MaterialUrlDto25> selectMaterialByIds(@Param("ids") Long[] ids);


    /**
     * 说明：获取公益图片，1-10是公益
     * @return
     */
    List<MaterialUrlDto25> selectMaterialListForPublic();

    /**
     * 说明：添加演示图片
     * @param pic 素材信息
     * @return
     */
    int insertDemoPic(Material25 pic);

    int updateDemoPic();

    Map selectDemoPic();
}
