package com.ruoyi.advertiser25.mapper;

import com.ruoyi.advertiser25.domain.Upgrade25;
import org.apache.ibatis.annotations.Update;

import java.util.List;

/**
 * 固件升级 Mapper接口
 * 
 * @author caiweigan
 * @date 2022-02-07
 */
public interface UpgradeMapper
{
    /**
     * 查询固件升级 
     * 
     * @param upgradeId 固件升级 主键
     * @return 固件升级 
     */
    public Upgrade25 selectAdFirmwareUpgradeByUpgradeId(Long upgradeId);

    /**
     * 查询固件升级 列表
     * 
     * @param adFirmwareUpgrade 固件升级 
     * @return 固件升级 集合
     */
    public List<Upgrade25> selectAdFirmwareUpgradeList(Upgrade25 adFirmwareUpgrade);

    /**
     * 新增固件升级 
     * 
     * @param adFirmwareUpgrade 固件升级 
     * @return 结果
     */
    public int insertAdFirmwareUpgrade(Upgrade25 adFirmwareUpgrade);

    /**
     * 修改固件升级 
     * 
     * @param adFirmwareUpgrade 固件升级 
     * @return 结果
     */
    public int updateAdFirmwareUpgrade(Upgrade25 adFirmwareUpgrade);

    /**
     * 删除固件升级 
     * 
     * @param upgradeId 固件升级 主键
     * @return 结果
     */
    public int deleteAdFirmwareUpgradeByUpgradeId(Long upgradeId);

    /**
     * 批量删除固件升级 
     * 
     * @param upgradeIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAdFirmwareUpgradeByUpgradeIds(Long[] upgradeIds);

    /**
     * 修改发布状态
     */
    @Update("UPDATE n25_upgrade SET publish_status = '1', publish_time = CURRENT_TIMESTAMP WHERE upgrade_id = #{upgradeId}")
    int updatePublishStatus(Long upgradeId);

    /**
     * 自动发布
     */
    @Update("UPDATE n25_upgrade SET publish_status = '1' WHERE publish_type = '0' AND publish_status = '0' AND CURRENT_TIMESTAMP >= publish_time")
    int autoUpdatePublishStatus();

    /**
     * 根据屏幕类型、硬件版本
     * 已发布状态、软件版本号排序 查询最新的固件包
     */
    Upgrade25 selectLatestFirmware(Upgrade25 adFirmwareUpgrade);
}
