package com.ruoyi.advertiser25.service;

import com.ruoyi.advertiser25.domain.AdHeartbeatData25;

import java.util.List;

/**
 * 拉手心跳数据Service接口
 *
 * @author zhangzhanwei
 * @date 2021-12-16
 */
public interface IDeviceHeartbeatService
{
    /**
     * 查询拉手心跳数据
     *
     * @param id 拉手心跳数据主键
     * @return 拉手心跳数据
     */
    public AdHeartbeatData25 selectAdHeartbeatDataById(Long id);

    /**
     * 查询拉手心跳数据列表
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 拉手心跳数据集合
     */
    public List<AdHeartbeatData25> selectAdHeartbeatDataList(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 新增拉手心跳数据
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 结果
     */
    public int insertAdHeartbeatData(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 修改拉手心跳数据
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 结果
     */
    public int updateAdHeartbeatData(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 批量删除拉手心跳数据
     *
     * @param ids 需要删除的拉手心跳数据主键集合
     * @return 结果
     */
    public int deleteAdHeartbeatDataByIds(Long[] ids);

    /**
     * 删除拉手心跳数据信息
     *
     * @param id 拉手心跳数据主键
     * @return 结果
     */
    public int deleteAdHeartbeatDataById(Long id);

    /**
     * 查询拉手及心跳信息
     */
    List<AdHeartbeatData25> selectAdHeartbeatDataInfoList(AdHeartbeatData25 adHeartbeatData25);

    /**
     * 查询拉手心跳数据
     *
     * @param imei
     * @return 拉手心跳数据
     */
    public AdHeartbeatData25 selectAdHeartbeatDataByImei(String imei);

}
