package com.ruoyi.advertiser25.service;

import com.ruoyi.advertiser25.domain.CarouselPlan25;
import com.ruoyi.advertiser25.domain.Material25;
import com.ruoyi.advertiser25.domain.PlanSetting25;
import com.ruoyi.advertiser25.domain.dto.*;
import com.ruoyi.advertiser25.domain.req.CarouselPlanParamReq25;
import com.ruoyi.common.core.domain.AjaxResult;

import java.util.Date;
import java.util.List;

/**
 * 广告轮播计划 Service接口
 *
 * @author zhangzhanwei
 * @date 2021-09-24
 */
public interface IRotationPlanService
{
    /**
     * 查询广告轮播计划 精确到列车
     *
     * @param carouselPlanParamVo
     * @return AjaxResult
     */
    AjaxResult selectPlanByParamVo(CarouselPlanParamReq25 carouselPlanParamVo);

    AjaxResult pushRedis();

    /**
     * 说明：获取整日的图片轮播数据
     * @param setting
     * @return AdCarouselPlanDayDto
     */
    public CarouselPlanDayDto25 getDayCarouselPlanData(PlanSetting25 setting);

    /**
     * 说明：获取redis里存储的当前列车轮播计划
     * @param key 列车id
     * @return
     */
    CarouselPlanRedisDto25 getCarouselPlanCache(String key);
}
