package com.ruoyi.advertiser25.service;

import com.ruoyi.advertiser25.domain.AdHandle25;

import java.util.List;

/**
 * 把手 Service接口
 *
 * @author zhangzhanwei
 * @date 2021-09-15
 */
public interface IScreenDeviceService {
    /**
     * 查询把手
     *
     * @param id 把手 ID
     * @return 把手
     */
    AdHandle25 selectAdHandleById(Long id);

    AdHandle25 selectAdHandleByImei(String imei);

    /**
     * 查询把手 列表
     *
     * @param adHandle25 把手
     * @return 把手 集合
     */
    List<AdHandle25> selectAdHandleList(AdHandle25 adHandle25);

    /**
     * 新增把手
     *
     * @param adHandle25 把手
     * @return 结果
     */
    int insertAdHandle(AdHandle25 adHandle25);

    /**
     * 修改把手
     *
     * @param adHandle25 把手
     * @return 结果
     */
    int updateAdHandle(AdHandle25 adHandle25);

    /**
     * 批量删除把手
     *
     * @param ids 需要删除的把手 ID
     * @return 结果
     */
    int deleteAdHandleByIds(Long[] ids);

    /**
     * 删除把手 信息
     *
     * @param id 把手 ID
     * @return 结果
     */
    int deleteAdHandleById(Long id);

    /**
     * 验证编号是否重复
     */
    String checkNumUnique(AdHandle25 adHandle25);

    /**
     * 根据心跳修改拉手信息
     */
    void updateHandleByHeartbeat(AdHandle25 adHandle25);

    /**
     * 修改seId
     */
    void updateSeId(String imei, String seId);
}
