package com.ruoyi.advertiser25.service;

import com.ruoyi.advertiser25.domain.Material25;
import com.ruoyi.common.core.domain.AjaxResult;

import java.util.List;

/**
 * 广告素材 Service接口
 *
 * @author zhangzhanwei
 * @date 2021-09-13
 */
public interface IScreenMaterialService {

    /**
     * 查询广告素材 列表
     *
     * @param material25 广告素材
     * @return 广告素材 集合
     */
    List<Material25> selectMaterialList(Material25 material25);

    /**
     * 新增广告素材
     *
     * @param material25 广告素材
     * @return 结果
     */
    int insertMaterial(Material25 material25);

    /**
     * 查询广告素材
     *
     * @param id 广告素材 ID
     * @return 广告素材
     */
    Material25 selectMaterialById(Long id);

    /**
     * 修改广告素材
     *
     * @param material25 广告素材
     * @return 结果
     */
    int updateMaterial(Material25 material25);

    /**
     * 批量删除广告素材
     *
     * @param ids 需要删除的广告素材 ID
     * @return 结果
     */
    int deleteMaterialByIds(Long[] ids);

    /**
     * 通过广告素材
     * @param material25
     * @return
     */
    AjaxResult passMaterial(Material25 material25);

    AjaxResult demo(Long id);
    AjaxResult getDemoPic();

}
