package com.ruoyi.advertiser25.service;

import com.ruoyi.advertiser25.domain.Upgrade25;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

/**
 * 固件升级 Service接口
 * 
 * @author caiweigan
 * @date 2022-02-07
 */
public interface IUpgradeService
{
    /**
     * 查询固件升级 
     * 
     * @param upgradeId 固件升级 主键
     * @return 固件升级 
     */
    public Upgrade25 selectAdFirmwareUpgradeByUpgradeId(Long upgradeId);

    /**
     * 查询固件升级 列表
     * 
     * @param adFirmwareUpgrade 固件升级 
     * @return 固件升级 集合
     */
    public List<Upgrade25> selectAdFirmwareUpgradeList(Upgrade25 adFirmwareUpgrade);

    /**
     * 新增固件升级 
     * 
     * @param adFirmwareUpgrade 固件升级 
     * @return 结果
     */
    public int insertAdFirmwareUpgrade(Upgrade25 adFirmwareUpgrade);

    /**
     * 修改固件升级 
     * 
     * @param adFirmwareUpgrade 固件升级 
     * @return 结果
     */
    public int updateAdFirmwareUpgrade(Upgrade25 adFirmwareUpgrade);

    /**
     * 批量删除固件升级 
     * 
     * @param upgradeIds 需要删除的固件升级 主键集合
     * @return 结果
     */
    public int deleteAdFirmwareUpgradeByUpgradeIds(Long[] upgradeIds);

    /**
     * 删除固件升级 信息
     * 
     * @param upgradeId 固件升级 主键
     * @return 结果
     */
    public int deleteAdFirmwareUpgradeByUpgradeId(Long upgradeId);

    /**
     * 修改发布状态
     */
    int updatePublishStatus(Long upgradeId);

    /**
     * SE-TSM签名
     */
    void signature(Upgrade25 adFirmwareUpgrade);

    /**
     * 根据屏幕类型、硬件版本
     * 已发布状态、软件版本号排序 查询最新的固件包
     */
    Upgrade25 selectLatestFirmware(Upgrade25 adFirmwareUpgrade);

    /**
     * 上传固件包
     */
    Upgrade25 upload(MultipartFile file) throws IOException;
}
