package com.ruoyi.advertiser25.service.impl;

import com.ruoyi.advertiser25.domain.AdHeartbeatData25;
import com.ruoyi.advertiser25.mapper.DeviceHeartbeatMapper;
import com.ruoyi.advertiser25.service.IDeviceHeartbeatService;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Calendar;
import java.util.List;

/**
 * 拉手心跳数据Service业务层处理
 *
 * @author zhangzhanwei
 * @date 2021-12-16
 */
@Service
public class DeviceHeartbeatServiceImpl implements IDeviceHeartbeatService
{
    @Resource
    private DeviceHeartbeatMapper deviceHeartbeatMapper;

    /**
     * 查询拉手心跳数据
     *
     * @param id 拉手心跳数据主键
     * @return 拉手心跳数据
     */
    @Override
    public AdHeartbeatData25 selectAdHeartbeatDataById(Long id)
    {
        return deviceHeartbeatMapper.selectAdHeartbeatDataById(id);
    }

    /**
     * 查询拉手心跳数据列表
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 拉手心跳数据
     */
    @Override
    public List<AdHeartbeatData25> selectAdHeartbeatDataList(AdHeartbeatData25 adHeartbeatData25)
    {
        return deviceHeartbeatMapper.selectAdHeartbeatDataList(adHeartbeatData25);
    }



    /**
     * 新增拉手心跳数据
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 结果
     */
    @Override
    public int insertAdHeartbeatData(AdHeartbeatData25 adHeartbeatData25)
    {
        return deviceHeartbeatMapper.insertAdHeartbeatData(adHeartbeatData25);
    }

    /**
     * 修改拉手心跳数据
     *
     * @param adHeartbeatData25 拉手心跳数据
     * @return 结果
     */
    @Override
    public int updateAdHeartbeatData(AdHeartbeatData25 adHeartbeatData25)
    {
        adHeartbeatData25.setUpdateTime(DateUtils.getNowDate());
        return deviceHeartbeatMapper.updateAdHeartbeatData(adHeartbeatData25);
    }

    /**
     * 批量删除拉手心跳数据
     *
     * @param ids 需要删除的拉手心跳数据主键
     * @return 结果
     */
    @Override
    public int deleteAdHeartbeatDataByIds(Long[] ids)
    {
        return deviceHeartbeatMapper.deleteAdHeartbeatDataByIds(ids);
    }

    /**
     * 删除拉手心跳数据信息
     *
     * @param id 拉手心跳数据主键
     * @return 结果
     */
    @Override
    public int deleteAdHeartbeatDataById(Long id)
    {
        return deviceHeartbeatMapper.deleteAdHeartbeatDataById(id);
    }

    @Override
    public List<AdHeartbeatData25> selectAdHeartbeatDataInfoList(AdHeartbeatData25 adHeartbeatData25) {

        Calendar date = Calendar.getInstance();
        date.add(Calendar.DAY_OF_YEAR,-30);
        adHeartbeatData25.setUpdateTime(date.getTime());
        List<AdHeartbeatData25> list = deviceHeartbeatMapper.selectAdHeartbeatDataInfoList(adHeartbeatData25);
        return list;
    }

    @Override
    public AdHeartbeatData25 selectAdHeartbeatDataByImei(String imei) {
        return deviceHeartbeatMapper.selectAdHeartbeatDataByImei(imei);
    }
}
