package com.ruoyi.mcu25.common;

import com.ruoyi.common.utils.spring.SpringUtils;
import com.ruoyi.mcu25.config.McuSocketConfig25;
import com.ruoyi.mcu25.server.DealChannel25;

import java.io.IOException;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.SocketChannel;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @author wzsdch_p751
 * @date 2022/07/18 13:09
 **/
public class EventLoopGroup25 {



    private EventLoop25[] eventLoop25s;


    private List<DealChannel25> dealChannel25List;

    private final AtomicInteger idx = new AtomicInteger(0);

    public EventLoopGroup25() throws IOException {
        //创建事件池
        McuSocketConfig25 mcuSocketConfig25 = SpringUtils.getBean("mcuSocketConfig25");
        this.eventLoop25s = new EventLoop25[mcuSocketConfig25.getDealThreadQuantity()];
        for (int i = 0; i < eventLoop25s.length; i++) {
            eventLoop25s[i] = new EventLoop25();
        }
        dealChannel25List = new LinkedList<>();
    }

    public EventLoop25[] getEventLoops() {
        return eventLoop25s;
    }

    public EventLoop25 next(){
        //轮询处理，指向下一个事件类
        int nextint = idx.getAndIncrement() & eventLoop25s.length-1;
        return eventLoop25s[nextint];
    }

    /**
     * 注册事件处理
     * @param socketChannel
     * @param keyOps
     * @throws ClosedChannelException
     */
    public void  register(SocketChannel socketChannel, int keyOps) throws InterruptedException {
        next().register(socketChannel,keyOps, dealChannel25List);
    }

    public List<DealChannel25> getDealChannelList() {
        return dealChannel25List;
    }
}
