package com.ruoyi.mcu25.common;

import com.ruoyi.mcu25.server.DealChannel25;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.nio.channels.SocketChannel;
import java.util.Iterator;

/**
 * @author wzsdch_p751
 * @date 2022/08/04 09:44
 **/

@Component
@Slf4j(topic = "sys-mcu25")
public class SocketClosingTask25 {

    @Autowired
    private EventLoopGroup25 eventLoopGroup25;

    private Long expireTime=60000L;


    @Scheduled(fixedRate=10000)
    public void configureTasks() {
        Long nowDate = System.currentTimeMillis();
        Iterator<DealChannel25> iterator = eventLoopGroup25.getDealChannelList().iterator();
        while(iterator.hasNext()){
            DealChannel25 dealChannel25 = iterator.next();
            //当前时间-最后一次设备通讯时间大于60，则关闭这个连接
            if((nowDate- dealChannel25.getLastReadDate())>expireTime){
                iterator.remove();
                try {
                    SocketChannel channel = dealChannel25.getChannel();
                    channel.close();
                    log.info("关闭超时连接成功！imei:{},eventLoopGroup中剩余数量：{}", dealChannel25.getImei(), eventLoopGroup25.getDealChannelList().size());
                }catch (IOException e)
                {
                    String remoteAddress="";
                    try {
                       remoteAddress = dealChannel25.getChannel().getRemoteAddress().toString();
                    }catch (IOException e2)
                    {
                        log.warn("关闭连接发送错误2");
                    }
                    log.warn("关闭连接发送错误,设备ip:{}",remoteAddress);
                }
            }
        }
    }
}
