import request from '@/utils/request'

// 查询把手 列表
export function listHandle(query) {
  return request({
    url: '/advertising25/handle/list',
    method: 'get',
    params: query
  })
}

// 查询把手 详细
export function getHandle(id) {
  return request({
    url: '/advertising25/handle/' + id,
    method: 'get'
  })
}

// 新增把手
export function addHandle(data) {
  return request({
    url: '/advertising25/handle',
    method: 'post',
    data: data
  })
}

// 修改把手
export function updateHandle(data) {
  return request({
    url: '/advertising25/handle',
    method: 'put',
    data: data
  })
}

// 删除把手
export function delHandle(id) {
  return request({
    url: '/advertising25/handle/' + id,
    method: 'delete'
  })
}

// 导出把手
export function exportHandle(query) {
  return request({
    url: '/advertising25/handle/export',
    method: 'get',
    params: query
  })
}

// 下载导入模板
export function importTemplate() {
  return request({
    url: '/advertising25/handle/importTemplate',
    method: 'get'
  })
}

// 查询拉手状态
export function getHandleStatus() {
  return request({
    url: '/advertising25/handle/mqtt/status',
    method: 'get'
  })
}
