import request from '@/utils/request'

// 查询广告素材 列表
export function listMaterial(query) {
  return request({
    url: '/advertising25/material/list',
    method: 'get',
    params: query
  })
}

// 查询广告素材 详细
export function getMaterial(id) {
  return request({
    url: '/advertising25/material/' + id,
    method: 'get'
  })
}

// 新增广告素材
export function addMaterial(data) {
  return request({
    url: '/advertising25/material',
    method: 'post',
    data: data
  })
}

// 修改广告素材
export function updateMaterial(data) {
  return request({
    url: '/advertising25/material',
    method: 'put',
    data: data
  })
}

// 删除广告素材
export function delMaterial(id) {
  return request({
    url: '/advertising25/material/' + id,
    method: 'delete'
  })
}

// 通过广告素材
export function passMaterial(data) {
  return request({
    url: '/advertising25/material/pass',
    method: 'put',
    data: data
  })
}

// 设备为演示模式素材
export function setDemoMaterial(id) {
  return request({
    url: '/advertising25/material/demo/'+ id,
    method: 'get',
  })
}

export function getDemoMaterial(){
  return request({
    url: '/advertising25/material/getDemoPic',
    method: 'get'
  })
}
