import request from '@/utils/request'

// 查询固件升级 列表
export function listUpgrade(query) {
  return request({
    url: '/advertising25/upgrade/list',
    method: 'get',
    params: query
  })
}

// 查询固件升级 详细
export function getUpgrade(upgradeId) {
  return request({
    url: '/advertising25/upgrade/' + upgradeId,
    method: 'get'
  })
}

// 新增固件升级
export function addUpgrade(data) {
  return request({
    url: '/advertising25/upgrade',
    method: 'post',
    data: data
  })
}

// 修改固件升级
export function updateUpgrade(data) {
  return request({
    url: '/advertising25/upgrade',
    method: 'put',
    data: data
  })
}

// 删除固件升级
export function delUpgrade(upgradeId) {
  return request({
    url: '/advertising25/upgrade/' + upgradeId,
    method: 'delete'
  })
}

// 导出固件升级
export function exportUpgrade(query) {
  return request({
    url: '/advertising25/upgrade/export',
    method: 'get',
    params: query
  })
}

// 发布
export function publishUpgrade(upgradeId) {
  return request({
    url: '/advertising25/upgrade/publish_status/' + upgradeId,
    method: 'put',
  })
}
